using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule.DayView;
using Infragistics.Win.UltraWinSchedule;

namespace WinDayViewDragDropFromListView
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void listView1_ItemDrag(object sender, ItemDragEventArgs e)
        {
            this.DoDragDrop(e.Item as ListViewItem, DragDropEffects.Move);
        }

        private void listView1_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void ultraDayView1_DragEnter(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
        }

        private void ultraDayView1_DragOver(object sender, DragEventArgs e)
        {
            e.Effect = DragDropEffects.Move;
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void ultraDayView1_DragDrop(object sender, DragEventArgs e)
        {
            Point clientPoint = this.ultraDayView1.PointToClient(Form1.MousePosition);
            TimeSlot tslot = this.ultraDayView1.GetTimeSlotFromPoint(clientPoint);
            
            if (tslot != null)
            {
                VisibleDay vday = this.ultraDayView1.GetVisibleDayFromPoint(clientPoint);
                if (vday != null)
                {
                    Appointment appt = new Appointment(new DateTime(vday.Date.Year, vday.Date.Month, vday.Date.Day, tslot.StartTime.Hour, tslot.StartTime.Minute, tslot.StartTime.Second),
                        new DateTime(vday.Date.Year, vday.Date.Month, vday.Date.Day, tslot.EndTime.Hour, tslot.EndTime.Minute + 1, tslot.EndTime.Second));
                    appt.Subject = ((ListViewItem)e.Data.GetData(typeof(ListViewItem))).Text;
                    this.ultraCalendarInfo1.Appointments.Add(appt);
                }
                else
                {
                    MessageBox.Show("Visible Day not found!");
                }
            }
            else
            {
                MessageBox.Show("TimeSlot not found!");
            }
        }
        
    }
}